"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
var _exportNames = {
  skeleton: true,
  plugins: true,
  project: true,
  setters: true,
  material: true,
  config: true,
  event: true,
  editor: true,
  logger: true,
  hotkey: true,
  common: true,
  isOpenSource: true,
  __SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED: true,
  version: true,
  init: true,
  destroy: true
};
exports.config = exports.common = exports.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = void 0;
exports.destroy = destroy;
exports.hotkey = exports.event = exports.editor = void 0;
exports.init = init;
exports.version = exports.skeleton = exports.setters = exports.project = exports.plugins = exports.material = exports.logger = exports.isOpenSource = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _react = require("react");
var _reactDom = require("react-dom");
var _lowcodeEditorCore = require("@alilc/lowcode-editor-core");
var _lowcodeDesigner = require("@alilc/lowcode-designer");
var _lowcodeEditorSkeleton = require("@alilc/lowcode-editor-skeleton");
var _lowcodePluginOutlinePane = _interopRequireWildcard(require("@alilc/lowcode-plugin-outline-pane"));
var _lowcodePluginDesigner = _interopRequireDefault(require("@alilc/lowcode-plugin-designer"));
var _lowcodeShell = require("@alilc/lowcode-shell");
var _lowcodeUtils = require("@alilc/lowcode-utils");
require("./modules/live-editing");
var _classes = _interopRequireDefault(require("./modules/classes"));
var _symbols = _interopRequireDefault(require("./modules/symbols"));
var _shellModelFactory = require("./modules/shell-model-factory");
var _skeletonTypes = require("./modules/skeleton-types");
Object.keys(_skeletonTypes).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _skeletonTypes[key]) return;
  exports[key] = _skeletonTypes[key];
});
var _designerTypes = require("./modules/designer-types");
Object.keys(_designerTypes).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _designerTypes[key]) return;
  exports[key] = _designerTypes[key];
});
var _lowcodeTypes = require("./modules/lowcode-types");
Object.keys(_lowcodeTypes).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _lowcodeTypes[key]) return;
  exports[key] = _lowcodeTypes[key];
});
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/* eslint-disable no-param-reassign */

(0, _lowcodeEditorSkeleton.registerDefaults)();
var editor = new _lowcodeEditorCore.Editor();
_lowcodeEditorCore.globalContext.register(editor, _lowcodeEditorCore.Editor);
_lowcodeEditorCore.globalContext.register(editor, 'editor');
var innerSkeleton = new _lowcodeEditorSkeleton.Skeleton(editor);
editor.set('skeleton', innerSkeleton);
var designer = new _lowcodeDesigner.Designer({
  editor: editor,
  shellModelFactory: _shellModelFactory.shellModelFactory
});
editor.set('designer', designer);
var innerProject = designer.project;
var hotkey = new _lowcodeShell.Hotkey();
exports.hotkey = hotkey;
var project = new _lowcodeShell.Project(innerProject);
exports.project = project;
var skeleton = new _lowcodeShell.Skeleton(innerSkeleton);
exports.skeleton = skeleton;
var setters = new _lowcodeShell.Setters();
exports.setters = setters;
var material = new _lowcodeShell.Material(editor);
exports.material = material;
var config = _lowcodeEditorCore.engineConfig;
exports.config = config;
var event = new _lowcodeShell.Event(editor, {
  prefix: 'common'
});
exports.editor = exports.event = event;
var logger = (0, _lowcodeUtils.getLogger)({
  level: 'warn',
  bizName: 'common'
});
exports.logger = logger;
var common = new _lowcodeShell.Common(editor, innerSkeleton);
exports.common = common;
var pluginContextApiAssembler = {
  assembleApis: function assembleApis(context) {
    context.hotkey = hotkey;
    context.project = project;
    context.skeleton = skeleton;
    context.setters = setters;
    context.material = material;
    context.event = event;
    context.config = config;
    context.common = common;
  }
};
var plugins = new _lowcodeDesigner.LowCodePluginManager(pluginContextApiAssembler).toProxy();
exports.plugins = plugins;
editor.set('plugins', plugins);
// declare this is open-source version
var isOpenSource = true;
exports.isOpenSource = isOpenSource;
var __SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = {
  symbols: _symbols["default"],
  classes: _classes["default"]
};
exports.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = __SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
_lowcodeEditorCore.engineConfig.set('isOpenSource', isOpenSource);

// 注册一批内置插件
(function () {
  var _registerPlugins = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    var componentMetaParser, setterRegistry, defaultPanelRegistry;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            // 处理 editor.set('assets')，将组件元数据创建好
            componentMetaParser = function componentMetaParser(ctx) {
              return {
                init: function init() {
                  editor.onGot('assets', function (assets) {
                    var _assets$components = assets.components,
                      components = _assets$components === void 0 ? [] : _assets$components;
                    designer.buildComponentMetasMap(components);
                  });
                }
              };
            };
            componentMetaParser.pluginName = '___component_meta_parser___';
            _context.next = 4;
            return plugins.register(componentMetaParser);
          case 4:
            // 注册默认的 setters
            setterRegistry = function setterRegistry(ctx) {
              return {
                init: function init() {
                  var _require;
                  if (_lowcodeEditorCore.engineConfig.get('disableDefaultSetters')) return;
                  var builtinSetters = (_require = require('@alilc/lowcode-engine-ext')) === null || _require === void 0 ? void 0 : _require.setters;
                  if (builtinSetters) {
                    ctx.setters.registerSetter(builtinSetters);
                  }
                }
              };
            };
            setterRegistry.pluginName = '___setter_registry___';
            _context.next = 8;
            return plugins.register(setterRegistry);
          case 8:
            // 注册默认的面板
            defaultPanelRegistry = function defaultPanelRegistry(ctx) {
              return {
                init: function init() {
                  var _editor$getPreference;
                  skeleton.add({
                    area: 'mainArea',
                    name: 'designer',
                    type: 'Widget',
                    content: _lowcodePluginDesigner["default"]
                  });
                  if (!_lowcodeEditorCore.engineConfig.get('disableDefaultSettingPanel')) {
                    skeleton.add({
                      area: 'rightArea',
                      name: 'settingsPane',
                      type: 'Panel',
                      content: _lowcodeEditorSkeleton.SettingsPrimaryPane,
                      props: {
                        ignoreRoot: true
                      }
                    });
                  }

                  // by default in float area;
                  var isInFloatArea = true;
                  var hasPreferenceForOutline = editor === null || editor === void 0 ? void 0 : (_editor$getPreference = editor.getPreference()) === null || _editor$getPreference === void 0 ? void 0 : _editor$getPreference.contains('outline-pane-pinned-status-isFloat', 'skeleton');
                  if (hasPreferenceForOutline) {
                    var _editor$getPreference2;
                    isInFloatArea = editor === null || editor === void 0 ? void 0 : (_editor$getPreference2 = editor.getPreference()) === null || _editor$getPreference2 === void 0 ? void 0 : _editor$getPreference2.get('outline-pane-pinned-status-isFloat', 'skeleton');
                  }
                  skeleton.add({
                    area: 'leftArea',
                    name: 'outlinePane',
                    type: 'PanelDock',
                    content: _lowcodePluginOutlinePane["default"],
                    panelProps: (0, _extends2["default"])({
                      area: isInFloatArea ? 'leftFloatArea' : 'leftFixedArea',
                      keepVisibleWhileDragging: true
                    }, _lowcodeEditorCore.engineConfig.get('defaultOutlinePaneProps'))
                  });
                  skeleton.add({
                    area: 'rightArea',
                    name: 'backupOutline',
                    type: 'Panel',
                    props: {
                      condition: function condition() {
                        return designer.dragon.dragging && !(0, _lowcodePluginOutlinePane.getTreeMaster)(designer).hasVisibleTreeBoard();
                      }
                    },
                    content: _lowcodePluginOutlinePane.OutlineBackupPane
                  });
                }
              };
            };
            defaultPanelRegistry.pluginName = '___default_panel___';
            _context.next = 12;
            return plugins.register(defaultPanelRegistry);
          case 12:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  function registerPlugins() {
    return _registerPlugins.apply(this, arguments);
  }
  return registerPlugins;
})()();

// container which will host LowCodeEngine DOM
var engineContainer;
// @ts-ignore webpack Define variable
var version = VERSION_PLACEHOLDER;
exports.version = version;
_lowcodeEditorCore.engineConfig.set('ENGINE_VERSION', version);
function init(_x, _x2, _x3) {
  return _init.apply(this, arguments);
}
function _init() {
  _init = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(container, options, pluginPreference) {
    var engineOptions, Workbench;
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return destroy();
          case 2:
            engineOptions = null;
            if ((0, _lowcodeUtils.isPlainObject)(container)) {
              engineOptions = container;
              engineContainer = document.createElement('div');
              engineContainer.id = 'engine';
              document.body.appendChild(engineContainer);
            } else {
              engineOptions = options;
              engineContainer = container;
              if (!container) {
                engineContainer = document.createElement('div');
                engineContainer.id = 'engine';
                document.body.appendChild(engineContainer);
              }
            }
            _lowcodeEditorCore.engineConfig.setEngineOptions(engineOptions);
            _context2.next = 7;
            return plugins.init(pluginPreference);
          case 7:
            Workbench = common.skeletonCabin.Workbench;
            (0, _reactDom.render)( /*#__PURE__*/(0, _react.createElement)(Workbench, {
              skeleton: innerSkeleton,
              className: 'engine-main',
              topAreaItemClassName: 'engine-actionitem'
            }), engineContainer);
          case 9:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _init.apply(this, arguments);
}
function destroy() {
  return _destroy.apply(this, arguments);
}
function _destroy() {
  _destroy = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
    var documents;
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            // remove all documents
            documents = project.documents;
            if (Array.isArray(documents) && documents.length > 0) {
              documents.forEach(function (doc) {
                return project.removeDocument(doc);
              });
            }

            // TODO: delete plugins except for core plugins

            // unmount DOM container, this will trigger React componentWillUnmount lifeCycle,
            // so necessary cleanups will be done.
            engineContainer && (0, _reactDom.unmountComponentAtNode)(engineContainer);
          case 3:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _destroy.apply(this, arguments);
}